DigitalSignMultiText = {}

--Rember to not change node ids for text elements they have to be 
--0>0|0
--0>0|1
--0>0|2
--0>0|3

local TextSeparator = "-" --This is char that separates two lines, this symbol can be changed by you here in code, when player use this char in any of the lines it will disapeer from in game text

--text parameters can be changed here
local MaxSingleLineChars = 10
local FontName = "GENERIC"

local FirstLineAlignment = RenderText.ALIGN_CENTER
local FirstLineSize = 0.11
local FirstLineScaleX = 1
local FirstLineScaleY = 1
local FirstLineEmissiveScale = 0.2
local FirstLineColor = {0, 0, 0, 1}

local SecondLineAlignment = RenderText.ALIGN_CENTER
local SecondLineSize = 0.11
local SecondLineScaleX = 1
local SecondLineScaleY = 1
local SecondLineEmissiveScale = 0.2
local SecondLineColor = {0, 0, 0, 1}

function DigitalSignMultiText:IsDigitalSignMultiText(text)
    if text == "Town-Entry" then
        return true
    end
    if text == "Town-Entry" then
        return true
    end
    if text == "Ort-Eingang" then
        return true
    end
    if text == "Town-Entry" then
        return true
    end
    if text == "Town-Entry" then
        return true
    end
    if text == "Town-Entry" then
        return true
    end
    return false
end

function DigitalSignMultiText:DistanceFrom(x1, y1, x2, y2)
    return math.sqrt((x2 - x1) ^ 2 + (y2 - y1) ^ 2)
end

function DigitalSignMultiText:GetAllSigns()
    Signs = {}
    for i = #g_currentMission.placeableSystem.placeables, 1, -1 do
        local Cplaceable = g_currentMission.placeableSystem.placeables[i]
        if Cplaceable ~= nil and DigitalSignMultiText:IsDigitalSignMultiText(Cplaceable.storeItem.name) then
            Signs[table.getn(Signs) + 1] = Cplaceable
        end
    end
    return Signs
end

function DigitalSignMultiText:GetSignInRange()
    local Px, Py, Pz = getTranslation(g_currentMission.player.rootNode)

    local AllSigns = DigitalSignMultiText:GetAllSigns()
    if AllSigns == nil or table.getn(AllSigns) < 1 then
        return
    end

    for i = 1, table.getn(AllSigns) do
        local CurrentSign = AllSigns[i]
        if
            DigitalSignMultiText:DistanceFrom(Px, Pz, CurrentSign.position.x, CurrentSign.position.z) < 1 and
                CurrentSign:getOwnerFarmId() == g_currentMission.player.farmId
         then
            return CurrentSign
        end
    end

    return nil
end

function DigitalSignMultiText:FormatText(Text)
    for i = 1, (MaxSingleLineChars - string.len(Text)) / 2 do
        Text = "_" .. Text .. "_"
    end

    return Text
end

local TimerI = 0
local MaxTimerI = g_gameSettings:getValue(GameSettings.SETTING.FRAME_LIMIT)

function DigitalSignMultiText:Timer()
    TimerI = TimerI + 1
    if TimerI < MaxTimerI then
        return false
    end
    TimerI = 0
    return true
end

function DigitalSignMultiText:update()
    if not DigitalSignMultiText:Timer() then
        return
    end

    local AllSigns = DigitalSignMultiText:GetAllSigns()
    if AllSigns == nil or table.getn(AllSigns) < 1 then
        return
    end

    DigitalSignMultiText:InitSings(AllSigns)
    DigitalSignMultiText:UpdateTexts(AllSigns)
end

function DigitalSignMultiText:loadMap()
    if g_currentMission:getIsClient() then
        Player.registerActionEvents =
            Utils.appendedFunction(Player.registerActionEvents, DigitalSignMultiText.RegisterActionEvents)
        Player.updateActionEvents = Utils.appendedFunction(Player.updateActionEvents, DigitalSignMultiText.UpdateActionEvents)
    end
end

function DigitalSignMultiText:RegisterActionEvents()
    if self.isClient then
        DigitalSignMultiText.events = {}
        local valid1, eventId1 =
            g_inputBinding:registerActionEvent(
            InputAction.TOWNSIGN_MULTIRENAMEACTION,
            "TOWNSIGN_MULTIRENAMEACTION",
            DigitalSignMultiText.RenameEvent,
            false,
            true,
            false,
            true
        )
        if valid1 then
            table.insert(DigitalSignMultiText.events, eventId1)
            g_inputBinding:setActionEventTextVisibility(eventId1, true)
            self.RenameEventId2 = eventId1
        end
    end
end

function DigitalSignMultiText:UpdateActionEvents()
    if self.RenameEventId2 ~= nil then
        local InRange = DigitalSignMultiText:GetSignInRange()
        g_inputBinding:setActionEventActive(self.RenameEventId2, InRange ~= nil)
    end
end

function DigitalSignMultiText:ValidateText(text)

    local NewText = ""
    for i = 1, #text do
        local c = text:sub(i, i)
        if c ~= TextSeparator then
            NewText = NewText .. c
        end
    end

    return NewText
end

function DigitalSignMultiText:RenameEvent(actionName, keyStatus, arg3, arg4, arg5)

    local InRange = DigitalSignMultiText:GetSignInRange()
    if InRange == nil then
        return
    end

    local FirstLine = ""
    local SecondLine = ""

    local LastName = InRange:getName()

    if string.find(LastName, TextSeparator) == nil then
        LastName = LastName .. TextSeparator .. "";
    end

    FirstLine = string.sub(LastName, 1, string.find(LastName, TextSeparator) - 1)
    SecondLine = string.sub(LastName, string.find(LastName, TextSeparator) + 1, string.len(LastName))

    g_gui:showTextInputDialog(
        {
            text = g_i18n:getText("text_FirstLine"),
            defaultText = FirstLine,
            callback = function(text, yes)
                if yes == false then return end
                FirstLine = text;
                g_gui:showTextInputDialog(
                    {
                        text = g_i18n:getText("text_SecondLine"),
                        defaultText = SecondLine,
                        callback = function(text, yes)
                            if yes == false then return end
                            SecondLine = text;
                            InRange:setName(DigitalSignMultiText:ValidateText(FirstLine) .. TextSeparator .. DigitalSignMultiText:ValidateText(SecondLine), false);
                        end
                    }
                )
            end
        }
    )
end

function DigitalSignMultiText:InitSings(AllSigns)
    for i = 1, table.getn(AllSigns) do
        local CurrentSign = AllSigns[i]

        local FontMaterial = g_materialManager:getFontMaterial(FontName, CurrentSign.customEnvironment)

        if CurrentSign.FontMaterialN == nil or CurrentSign.CharacterLineN == nil then
            local TextNode = getChildAt(getChildAt(getChildAt(CurrentSign.rootNode, 0), 0), 0)
            CurrentSign.FontMaterialN = FontMaterial
            CurrentSign.CharacterLineN =
                FontMaterial:createCharacterLine(
                TextNode,
                MaxSingleLineChars,
                FirstLineSize,
                FirstLineColor,
                nil,
                FirstLineEmissiveScale,
                FirstLineScaleX,
                FirstLineScaleY,
                FirstLineAlignment
            )
        end

        if CurrentSign.FontMaterialS == nil or CurrentSign.CharacterLineS == nil then
            local TextNode = getChildAt(getChildAt(getChildAt(CurrentSign.rootNode, 0), 0), 1)
            CurrentSign.FontMaterialS = FontMaterial
            CurrentSign.CharacterLineS =
                FontMaterial:createCharacterLine(
                TextNode,
                MaxSingleLineChars,
                FirstLineSize,
                FirstLineColor,
                nil,
                FirstLineEmissiveScale,
                FirstLineScaleX,
                FirstLineScaleY,
                FirstLineAlignment
            )
        end

        if CurrentSign.FontMaterialNB == nil or CurrentSign.CharacterLineNB == nil then
            local TextNode = getChildAt(getChildAt(getChildAt(CurrentSign.rootNode, 0), 0), 2)
            CurrentSign.FontMaterialNB = FontMaterial
            CurrentSign.CharacterLineNB =
                FontMaterial:createCharacterLine(
                TextNode,
                MaxSingleLineChars,
                SecondLineSize,
                SecondLineColor,
                nil,
                SecondLineEmissiveScale,
                SecondLineScaleX,
                SecondLineScaleY,
                SecondLineAlignment
            )
        end

        if CurrentSign.FontMaterialSB == nil or CurrentSign.CharacterLineSB == nil then
            local TextNode = getChildAt(getChildAt(getChildAt(CurrentSign.rootNode, 0), 0), 3)
            CurrentSign.FontMaterialSB = FontMaterial
            CurrentSign.CharacterLineSB =
                FontMaterial:createCharacterLine(
                TextNode,
                MaxSingleLineChars,
                SecondLineSize,
                SecondLineColor,
                nil,
                SecondLineEmissiveScale,
                SecondLineScaleX,
                SecondLineScaleY,
                SecondLineAlignment
            )
        end
    end
end

function DigitalSignMultiText:UpdateTexts(AllSigns)
    for i = 1, table.getn(AllSigns) do
        local CurrentSign = AllSigns[i]

        if CurrentSign.CharacterLineN ~= nil then
            local Text = CurrentSign:getName();

            if string.find(Text, TextSeparator) then
                CurrentSign.FontMaterialN:updateCharacterLine(
                    CurrentSign.CharacterLineN,
                    DigitalSignMultiText:FormatText(string.sub(Text, 1, string.find(Text, TextSeparator) - 1))
                )
                CurrentSign.FontMaterialS:updateCharacterLine(
                    CurrentSign.CharacterLineS,
                    DigitalSignMultiText:FormatText(string.sub(Text, 1, string.find(Text, TextSeparator) - 1))
                )

                CurrentSign.FontMaterialN:updateCharacterLine(
                    CurrentSign.CharacterLineNB,
                    DigitalSignMultiText:FormatText(string.sub(Text, string.find(Text, TextSeparator) + 1, string.len(Text)))
                )
                CurrentSign.FontMaterialS:updateCharacterLine(
                    CurrentSign.CharacterLineSB,
                    DigitalSignMultiText:FormatText(string.sub(Text, string.find(Text, TextSeparator) + 1, string.len(Text)))
                )
            else
                CurrentSign.FontMaterialN:updateCharacterLine(CurrentSign.CharacterLineN, DigitalSignMultiText:FormatText(Text))
                CurrentSign.FontMaterialS:updateCharacterLine(CurrentSign.CharacterLineS, DigitalSignMultiText:FormatText(Text))
                CurrentSign.FontMaterialNB:updateCharacterLine(CurrentSign.CharacterLineNB, "")
                CurrentSign.FontMaterialSB:updateCharacterLine(CurrentSign.CharacterLineSB, "")
            end
        end
    end
end

addModEventListener(DigitalSignMultiText)
